
function gettags(s)
  local tags={}
  -- Remove optional spaces from the tags.
  s = string.gsub(s, "\n", " ")
  s = string.gsub(s, " *< *", "<")
  s = string.gsub(s, " *> *", ">")

  -- Put all the tags in lowercase.
  s = string.gsub(s, "(<[^ >]+)", string.lower)

  --something like this...
  for w in string.gfind(s, "(<[^>]+)") do
    w = string.gsub(w, "<", "")
    table.insert(tags,w)
    gprintln(w)
    wait()
  end
  return tags
end

function getanchors(s,ext)
  local tags={}
  -- Remove optional spaces from the tags.
  s = string.gsub(s, "\n", " ")
  s = string.gsub(s, " *< *", "<")
  s = string.gsub(s, " *> *", ">")

  -- Put all the tags in lowercase.
  s = string.gsub(s, "(<a[^ >]+)", string.lower)

  --something like this...
--  for w in string.gfind(s, "(<a href=[^>]+)"..ext) do
  for w in string.gfind(s, "(=[^ >]+%.)"..ext) do
--    w = string.gsub(w, "<a href='", "")..ext
--    w = string.gsub(w, "<a href=\"", "")
    w = string.gsub(w, "='", "")..ext
    w = string.gsub(w, "=\"", "")
    table.insert(tags,w)
--    gprintln(w)
--    wait()
  end
  return tags
end


function buildtree(text,tags)
  local match = table.remove(tags,1)
  local tree = {}
  gprintln( match )
  while table.getn(tags)~=0 do
    
    match = table.remove(tags,1)
  end
    wait()
end

function html2table(text)
  local pad=Pad.new()
  local nt=''
  local root={}
  local parent = root
  for i=1,string.len(text) do
    if string.equals(string.sub(text,i,i),'<') then
      pad:Update()
      if pad.St then
        gprintln('i = ' .. i)
        wait()
        return
      end
      local tag = {}
      local endpos =string.indexOf(text,'>',i+1)
      local ttype = string.sub(text,i, endpos )
      local t2 = string.split(ttype,' ')
      t2 = string.split(t2[1],'>')
      local attr = {}
      local parts = string.split(ttype,' ')
      local idx=1
      tag.tag = string.sub( parts[1], 2, -1 )
      if string.contains(tag.tag,'>') then
        tag.tag=string.gsub(tag.tag,'>','')
        tag.tag=string.gsub(tag.tag,' ','')
      end
      --+ get tag attributes
      for j=1,table.getn(parts) do
        if string.contains(parts[j],'=') then
          local val=string.split(parts[j],'=')
          attr[idx]=val[1]
          val[2]=string.gsub(val[2],'\"','\'')
          val[2]=string.sub( val[2], string.indexOf(val[2],'\''), string.lastIndexOf(val[2],'\'')-1 )
          attr[val[1]]=val[2]
          idx=idx+1
        end
      end
      if table.getn(attr)>0 then
        tag.attr = attr
      end
      if string.endsWith(ttype,'/') then
        table.insert(root,tag)
      else
--        tag.inside = string.sub( text, endpos+1, string.indexOf( text, '/'..tag.tag, endpos+1)-string.len(tag.tag)-3 )
        local inside = string.sub( text, endpos+1, string.indexOf( text, '/'..tag.tag, endpos)-string.len(tag.tag)-2 )
        if string.endsWith(inside,'<') then
          inside = string.sub(inside,1,string.len(inside)-1)
        end
        
        i=string.find( text, '/'..tag.tag, endpos) or string.indexOf( text, '/'..tag.tag, endpos)
        if hastags(inside) then
--          gprintln('checking tags for ' .. inside)
--          table.insert(tag, html2table(inside))
          tag.inside = html2table(inside)
        else
          tag.inside = inside
        end
        table.insert(root,tag)
      end
    end 
  end
  for ke,va in root do 
  end
  return root
end

function printtag(tag,tabs)
  if not tabs then
    tabs=0
  end
  local ts=0
  for ke,va in tag do
    if type(va)~='table' then
      while ts<tabs do
        gprint('  ')
        ts=ts+1
      end
      ts=0
      gprintln( ke .. ' ' .. va )
    else
      gprintln(ke)
      printtag(va,tabs+1)
    end    
  end
--      wait()
end

function hastags(text)
  if string.contains(text,'<') and string.contains(text,'>') then
    return true
  end
  return nil
end